#encoding:UTF-8

import wx
import os
from textwrap import fill
import webbrowser



class MainFrame(wx.Frame):
    def __init__(self, parent,id):
        wx.Frame.__init__(self, parent,id,'Assemblex', size=(660,590))
	
	self.SetMinSize((400,300))
	
	self.inputfocus = 1
	self.outputfocus = 0
	self.AsmReadOnly = 0
	
	favicon = wx.Icon('icon.ico', wx.BITMAP_TYPE_ICO, 16, 16)
	wx.Frame.SetIcon(self, favicon)
	
	def Get8xData(event):
		dlg = wx.FileDialog(self, "Choose a file", self.dirname, "", '8xp Files (*.8xp)|*.8xp', wx.OPEN)
		if dlg.ShowModal() == wx.ID_OK:
			self.filename=dlg.GetFilename()
			self.dirname=dlg.GetDirectory()

			# Open the file, read the contents and set them into
			# the text edit window
			filehandle=open(os.path.join(self.dirname, self.filename),'r')
			filehandle.close()

			self.SetTitle('Assemblex - '+self.filename)
		
			hexvalues = open(self.filename, "rb").read().encode("hex")
			hexProgram = fill(hexvalues,16)
			
			hexProgramData = hexProgram[161:(len(hexProgram)-4)]
			hexProgramUpperData = hexProgramData.upper()
			
			self.inputText.SetValue(self.inputText.GetValue() + hexProgramUpperData)
		
		# Get rid of the dialog to keep things tidy
		dlg.Destroy()
		
	def hex2dec(s): #Converts Decimal Numbers to Hexadecimal Number
		return int(s, 16)	
	def check_validity(a_string):
		try:
			eval('0x'+a_string)
		except SyntaxError:
			return False
		return a_string 
		
	def OnAbout(event):
		description = 'Assemblex is a Z80 disassembler which goal is to disassemble files for Texas Instruments 83+ Series Calculators.\nAnother important function of this program is to allow Assembly programmers to program using Hexadecimal, since this program converts Hexadecimal to Assembly in almost real time.\n\nThis program was made by David Gomes and it should not be released anywhere without his approval.'
		info = wx.AboutDialogInfo()

		info.SetName('Assemblex')
		info.SetVersion('0.8.5')
		info.SetDescription(description)
		info.SetCopyright('(C) 2010 David Gomes')
		info.SetWebSite('http://www.davidgom.co.cc')
		info.AddDeveloper('David Gomes')
		info.AddArtist('David Gomes')

		wx.AboutBox(info)
	
	def OnGetOnlineHelp(event):
		webbrowser.open('http://www.omnimaga.org/index.php?board=85.0')
		webbrowser.open('http://cemetech.net/forum/index.php')
		
	self.dirname = ''
	def OnSaveASM(event):
		# Save away the edited text
		# Open the file, do an RU sure check for an overwrite!
		dlg = wx.FileDialog(self, "Choose a file", self.dirname, "", "Z80 Files (*.z80)|*.z80|Assembly files (*.asm)|*.asm", \
				wx.SAVE | wx.OVERWRITE_PROMPT)
		if dlg.ShowModal() == wx.ID_OK:
			# Grab the content to be saved
			itcontains = self.outputText.GetValue()

			# Open the file for write, write, close
			self.filename=dlg.GetFilename()
			self.dirname=dlg.GetDirectory()
			filehandle=open(os.path.join(self.dirname, self.filename),'w')
			filehandle.write(itcontains)
			filehandle.close()
			self.SetTitle('Assemblex - '+self.filename)
		# Get rid of the dialog to keep things tidy
		dlg.Destroy()
	filters = 'Text files (*.txt)|*.txt|Hexadecimal files (*.hex)|*.hex'
	def OnSaveHEX(event):
		# Save away the edited text
		# Open the file, do an RU sure check for an overwrite!
		dlg = wx.FileDialog(self, "Choose a file", self.dirname,"", filters, \
				wx.SAVE | wx.OVERWRITE_PROMPT)
		if dlg.ShowModal() == wx.ID_OK:
			# Grab the content to be saved
			itcontains = self.inputText.GetValue()

			# Open the file for write, write, close
			self.filename=dlg.GetFilename()
			self.dirname=dlg.GetDirectory()
			filehandle=open(os.path.join(self.dirname, self.filename),'w')
			filehandle.write(itcontains)
			filehandle.close()
			self.SetTitle('Assemblex - '+self.filename)
		# Get rid of the dialog to keep things tidy
		dlg.Destroy()
		
	def OnSaveASMHEX(event):
		# Save away the edited text
		# Open the file, do an RU sure check for an overwrite!
		dlg = wx.FileDialog(self, "Choose a file", self.dirname,"", "Text files (*.txt)|*.txt", \
				wx.SAVE | wx.OVERWRITE_PROMPT)
		if dlg.ShowModal() == wx.ID_OK:
			# Grab the content to be saved
			itcontains = 'Hexadecimal Code:\n\n' + self.inputText.GetValue() + '\n\nAssembly Code:\n\n' + self.outputText.GetValue()

			# Open the file for write, write, close
			self.filename=dlg.GetFilename()
			self.dirname=dlg.GetDirectory()
			filehandle=open(os.path.join(self.dirname, self.filename),'w')
			filehandle.write(itcontains)
			filehandle.close()
			self.SetTitle('Assemblex - '+self.filename)
		# Get rid of the dialog to keep things tidy
		dlg.Destroy()
	
	
	def OnOpen(event):
		# In this case, the dialog is created within the method because
		# the directory name, etc, may be changed during the running of the
		# application. In theory, you could create one earlier, store it in
		# your frame object and change it when it was called to reflect
		# current parameters / values
		dlg = wx.FileDialog(self, "Choose a file", self.dirname, "", filters, wx.OPEN)
		if dlg.ShowModal() == wx.ID_OK:
			self.filename=dlg.GetFilename()
			self.dirname=dlg.GetDirectory()

			# Open the file, read the contents and set them into
			# the text edit window
			filehandle=open(os.path.join(self.dirname, self.filename),'r')
			self.inputText.SetValue(filehandle.read())
			filehandle.close()

			# Report on name of latest file read
			self.SetTitle('Assemblex - '+self.filename)
			# Later - could be enhanced to include a "changed" flag whenever
			# the text is actually changed, could also be altered on "save" ...
		dlg.Destroy()
	def NewFile(event):
		dial = wx.MessageDialog(None, 'Are you sure to create a new file?', 'New File', 
			wx.YES_NO | wx.ICON_QUESTION)

		if dial.ShowModal() == wx.ID_YES:
			self.inputText.SetValue('')
			self.outputText.SetValue('')
			self.SetTitle('Assembly')
	
	def OnQuit(event):
		dial = wx.MessageDialog(None, 'Are you sure to quit?', 'Exit Assemblex', 
			wx.YES_NO | wx.ICON_QUESTION)
		if dial.ShowModal() == wx.ID_YES:
			self.Destroy()
	
	def Num2Hex(event):
		DecimalInput=wx.TextEntryDialog(None, "Enter the decimal:", 'Decimal to Hexadecimal', 'Enter decimal...')
		if DecimalInput.ShowModal()==wx.ID_OK:
			Decimal=int(DecimalInput.GetValue())
			hexCode = ((hex(Decimal)).upper())[2:]
			self.inputText.SetValue(self.inputText.GetValue() + str(hexCode))
			
	def Hex2Num(event):
		HexInput=wx.TextEntryDialog(None, "Enter the Hexadecimal code:", 'Hexadecimal to Decimal', 'Enter hexadecimal code...')
		if HexInput.ShowModal()==wx.ID_OK:
			Hex=HexInput.GetValue()
			hexstring=hex2dec(Hex)
			self.inputText.SetValue(self.inputText.GetValue() + str(hexstring))
			
	def GiveInputFocus(event):
		self.inputfocus = 1
	
	def RemoveInputFocus(event):
		self.inputfocus = 0
		
	def GiveOutputFocus(event):
		self.outputfocus = 1
	
	def RemoveOutputFocus(event):
		self.outputfocus = 0
	
	def SelectAll(event):
		if self.inputfocus == 1:
			self.inputText.SelectAll()
		if self.outputfocus == 1:
			self.outputText.SelectAll()
	
	def Undo(event):
		if self.inputfocus == 1:
			self.inputText.Undo()
		if self.outputfocus == 1:
			self.outputText.Undo()
	
	def Redo(event):
		if self.inputfocus == 1:
			self.inputText.Redo()
		if self.outputfocus == 1:
			self.outputText.Redo()
			
	def Cut(event):
		if self.inputfocus == 1:
			self.inputText.Cut()
		if self.outputfocus == 1:
			self.outputText.Cut()
			
	def Copy(event):
		if self.inputfocus == 1:
			self.inputText.Copy()
		if self.outputfocus == 1:
			self.outputText.Copy()
			
	def Paste(event):
		if self.inputfocus == 1:
			self.inputText.Paste()
		if self.outputfocus == 1:
			self.outputText.Paste()
			
	def Clear(event):
		if self.inputfocus == 1:
			self.inputText.SetValue('')
		if self.outputfocus == 1:
			self.outputText.SetValue('')

	def FindReplace(event):
		textToFindInput=wx.TextEntryDialog(None,"Enter the text to be replaced","Find and Replace",'Enter text...')
		if textToFindInput.ShowModal()==wx.ID_OK:
			textToFind=textToFindInput.GetValue()
			textToReplaceInput=wx.TextEntryDialog(None,"Enter the text to replace","Find and Replace",'Enter text...')
			if textToReplaceInput.ShowModal()==wx.ID_OK:
				textToReplace = textToReplaceInput.GetValue()
				if self.inputfocus == 1:
					self.inputText.SetValue(self.inputText.GetValue().replace(textToFind,textToReplace))
				if self.outputfocus == 1:
					self.outputText.SetValue(self.outputText.GetValue().replace(textToFind,textToReplace))
	
	def CountWords(event):
		if self.inputfocus == 1:
			inputLength = len(self.inputText.GetValue())
			charBox = wx.MessageDialog(None, 'Characters (with spaces): '+str(inputLength),'Characters/Words', wx.OK)
			errorAnswer = charBox.ShowModal()
			charBox.Destroy()
		if self.outputfocus == 1:
			outputLength = len(self.outputText.GetValue())
			charBox = wx.MessageDialog(None, 'Characters (with spaces): '+str(outputLength),'Characters/Words', wx.OK)
			errorAnswer = charBox.ShowModal()
			charBox.Destroy()
			
	def OnExport8xp(event):
		print "Exporting to 8xp"
	
	
	# THIS IS THE LIST OF OPCODES; DON'T CHANGE ANY ELEMENT OF ANY ARRAY

	bCallsCode = [u'EF0E41', u'EF5A40', u'EFDE40', u'EFF040', u'EFD240', u'EF2D46', u'EF0946', u'EF0646', u'EF7648', u'EFA543', u'EFA843', u'EF0241', u'EF524B', u'EF934C', u'EF784C', u'EF754C', u'EF4B40', u'EFD84F', u'EFE440', u'EFED40', u'EFDB40', u'EFE140', u'EFE740', u'EFD840', u'EFEA40', u'EFD540', u'EF6346', u'EFA84F', u'EF7450', u'EF7150', u'EF974E', u'EF884E', u'EF694C', u'EF944E', u'EFBB4E', u'EFA94E', u'EFC14E', u'EFF049', u'EFB350', u'EFF142', u'EFC44E', u'EFD447', u'EF3442', u'EF3742', u'EF2542', u'EFFC40', u'EF2842', u'EF5842', u'EFFF40', u'EF2B42', u'EF5542', u'EFDF42', u'EF3142', u'EF7042', u'EF504A', u'EF5C4D', u'EFED4C', u'EF9847', u'EF9B47', u'EFA04E', u'EFA34E', u'EFD348', u'EF6E47', u'EF6C49', u'EF354A', u'EF384A', u'EF4345', u'EF4045', u'EFD141', u'EF5E42', u'EF5B42', u'EF4945', u'EF4645', u'EF4C45', u'EFB84E', u'EF4A4A', u'EF8E4E', u'EFB54E', u'EF434B', u'EF464B', u'EF234A', u'EF564A', u'EFEF4A', u'EF0541', u'EFC040', u'EFCC40', u'EF0C40', u'EFC84D', u'EFF547', u'EF1141', u'EF0841', u'EF5C44', u'EF6B44', u'EF7744', u'EF8944', u'EF8344', u'EF7D44', u'EF8044', u'EF4A44', u'EF5944', u'EF6244', u'EF7444', u'EF8644', u'EF4444', u'EF5344', u'EF6544', u'EF4144', u'EF5644', u'EF7144', u'EF6844', u'EF4744', u'EF2944', u'EF3244', u'EFF343', u'EFD843', u'EF3B44', u'EF0844', u'EF0E44', u'EFDE43', u'EFE443', u'EFEA43', u'EFED43', u'EFF643', u'EF2344', u'EF2F44', u'EF3844', u'EF0244', u'EFF943', u'EFDB43', u'EFE143', u'EFE743', u'EFF043', u'EF2044', u'EF2C44', u'EF1144', u'EF1D44', u'EF1A44', u'EF1444', u'EFFF43', u'EFFC43', u'EF1744', u'EF5F44', u'EF6E44', u'EF7A44', u'EF4D44', u'EF5044', u'EF2A43', u'EF6A4E', u'EF1B43', u'EF0C43', u'EF3043', u'EF0D4B', u'EF3343', u'EF3943', u'EF6D4E', u'EF0F43', u'EF1543', u'EF2143', u'EF2743', u'EF914E', u'EF9D4E', u'EF8B4E', u'EF854E', u'EFA64E', u'EFBE4E', u'EF7B40', u'EFBE45', u'EFC445', u'EFAC4E', u'EFB24E', u'EFDD47', u'EFF247', u'EF6C43', u'EF6943', u'EF9F43', u'EFA243', u'EF6742', u'EF2F4A', u'EF5743', u'EF204A', u'EF5143', u'EFC64F', u'EFC94F', u'EF844C', u'EF454F', u'EFB545', u'EFA645', u'EF0745', u'EF9B4D', u'EF6550', u'EFF74B', u'EF0F40', u'EF1240', u'EF664C', u'EFC148', u'EF7D4D', u'EF8C4D', u'EF7540', u'EF324A', u'EF874C', u'EFFD42', u'EF7942', u'EFC442', u'EF5245', u'EF864D', u'EFAD44', u'EFCB44', u'EFBF44', u'EFD342', u'EFD042', u'EFCA42', u'EFC742', u'EFCD42', u'EFAA44', u'EFB344', u'EFB044', u'EF9844', u'EF9E44', u'EFA144', u'EFBC44', u'EFC844', u'EFD444', u'EFB944', u'EFA444', u'EF8C4A', u'EF8C44', u'EF9544', u'EFC544', u'EF9B44', u'EFC244', u'EFD144', u'EFA744', u'EFCE44', u'EFB644', u'EFB440', u'EFD543', u'EF2242', u'EF4F42', u'EF854B', u'EF624D', u'EF894D', u'EFF24A', u'EF474A', u'EF444A', u'EF4E4C', u'EF4B4C', u'EF9B50', u'EF484C', u'EFF442', u'EF7E46', u'EF3B4A', u'EF1750', u'EF8F50', u'EFAA50', u'EF9649', u'EF9049', u'EF9949', u'EF7B46', u'EF7240', u'EF9940', u'EF8440', u'EF9640', u'EF8140', u'EF6F40', u'EF9340', u'EF9445', u'EF6F4C', u'EF1840', u'EF7249', u'EF3646', u'EF1546', u'EFDD50', u'EF9145', u'EFD04B', u'EF6A48', u'EFD747', u'EFF940', u'EFA648', u'EF7642', u'EF604C', u'EF984D', u'EFE047', u'EF294A', u'EF2C4A', u'EFF742', u'EFA540', u'EF5D40', u'EFC748', u'EF5F4D', u'EF8D40', u'EF8A40', u'EF9040', u'EF6340', u'EF634C', u'EFE347', u'EFA342', u'EF2D49', u'EFD744', u'EF0040', u'EF2740', u'EF0550', u'EF0250', u'EFCA45', u'EF5140', u'EF7849', u'EF0940', u'EFAC48', u'EFAB40', u'EF8347', u'EF1D50', u'EF1A50', u'EFB14C', u'EFAE40', u'EF5740', u'EFE542', u'EF304C', u'EF334C', u'EF5440', u'EF6C40', u'EF5C41', u'EFDA47', u'EF6841', u'EF6541', u'EF5F41', u'EF7D41', u'EF0B41', u'EF7A41', u'EF8041', u'EF8341', u'EF2E45', u'EFE050', u'EFA34B', u'EF1F42', u'EF1942', u'EF1C42', u'EF0D42', u'EF1042', u'EF5242', u'EFBF41', u'EF9B41', u'EFA741', u'EFA141', u'EF9E41', u'EF2F41', u'EF2341', u'EF1741', u'EF5341', u'EF5041', u'EF1342', u'EF1642', u'EF0742', u'EFBC41', u'EFAD41', u'EFAA41', u'EF9841', u'EF9541', u'EF8F41', u'EFB04A', u'EF8C41', u'EF9241', u'EF5641', u'EF6E41', u'EF1A41', u'EF4A41', u'EF4D41', u'EFB941', u'EF8941', u'EFA441', u'EF3E41', u'EF2041', u'EF1441', u'EF4741', u'EFB641', u'EF8641', u'EF3841', u'EF1D41', u'EF7141', u'EF4441', u'EF7741', u'EF0A42', u'EFB341', u'EF3B41', u'EF2641', u'EF7441', u'EF2C41', u'EF2941', u'EF3541', u'EF3241', u'EF4141', u'EFB24B', u'EF2350', u'EF9B4A', u'EFA348', u'EFB548', u'EF6940', u'EFB248', u'EF394C', u'EF6F43', u'EF7E43', u'EF7B43', u'EF7843', u'EF9343', u'EF9043', u'EF8D43', u'EF8A43', u'EF8743', u'EF8443', u'EF8143', u'EF2E42', u'EFF340', u'EFCF43', u'EFC643', u'EFC943', u'EFC343', u'EFC043', u'EFBD43', u'EFBA43', u'EFB743', u'EFB443', u'EFB143', u'EFAE43', u'EFAB43', u'EF3c40', u'EF0445', u'EF0145', u'EF1045', u'EF0d45', u'EF0A45', u'EF6049', u'EF4546', u'EF1E46', u'EF7F4B', u'EF794B', u'EFDC42', u'EFD74A', u'EFD147', u'EFDD4A', u'EFE64A', u'EFE34A', u'EFE04A', u'EFDA4A', u'EFFA4E', u'EFFD4E', u'EF034F', u'EF264A', u'EF8E48', u'EF7147', u'EF364C', u'EF7048', u'EF7F42', u'EF9F40', u'EFA240', u'EFA840', u'EF7840', u'EFF640', u'EF7045', u'EF6D45', u'EF7B4C', u'EFE54E', u'EF144A', u'EFCC4F', u'EFBF50', u'EF4048', u'EFFC49', u'EF4948', u'EF4648', u'EF4348', u'EF004C', u'EF2050', u'EF8C47', u'EF8F47', u'EF9247', u'EF8647', u'EFD441', u'EFBD40', u'EFBA40', u'EFCF40', u'EFC640', u'EF9C40', u'EF124F', u'EF0F4F', u'EFB44C', u'EFE94A', u'EFBF4A', u'EFCE47', u'EFCB4A', u'EFD44A', u'EFC54A', u'EF7C4B', u'EFBC4A', u'EFCE4A', u'EFC24A', u'EFD14A', u'EFC84A', u'EFE344', u'EF3F4C', u'EFC340', u'EFC940', u'EFBB48', u'EFB740', u'EF7C42', u'EF7546', u'EF6640', u'EF7E40', u'EF8E42', u'EF5746', u'EF6040', u'EFD450', u'EF9547', u'EFAF48', u'EF7246', u'EFA948', u'EF5E45', u'EF6145', u'EF6445', u'EFFB47', u'EF0448', u'EFFE47', u'EF8842', u'EF9E47', u'EF0148', u'EF8B42', u'EFA147', u'EFB041', u'EFCE41', u'EFC541', u'EFC841', u'EFCB41', u'EF4F48', u'EF5B48', u'EF4C48', u'EF5248', u'EF5E48', u'EFA447', u'EF6148', u'EF5548', u'EF6748']
	
	bCallsName = [u'_AbsO1O2Cp', u'_AbsO1PAbsO2', u'_ACos', u'_ACosH', u'_ACosRad', u'_AdrLEle', u'_AdrMEle', u'_AdrMRow', u'_AllEq', u'_AllocFPS', u'_AllocFPS1', u'_Angle', u'_AnsName', u'_ApdSetup', u'_AppGetCalc', u'_AppGetCbl', u'_AppInit', u'_Arc_Unarc', u'_ASin', u'_ASinH', u'_ASinRad', u'_ATan', u'_ATan2', u'_ATan2Rad', u'_ATanH', u'_ATanRad', u'_BinOPExec', u'_Bit_VertSplit', u'_BufClr', u'_BufCpy', u'_CAbs', u'_CAdd', u'_CanAlphIns', u'_CDiv', u'_CDivByReal', u'_CEtoX', u'_CFrac', u'_CheckSplitFlag', u'_Chk_Batt_Low', u'_ChkFindSym', u'_CIntgr', u'_CircCmd', u'_CkInt', u'_CkOdd', u'_CkOP1C0', u'_CkOP1Cplx', u'_CkOP1FP0', u'_CkOP1Pos', u'_CkOP1Real', u'_CkOP2FP0', u'_CkOP2Pos', u'_CkOP2Real', u'_CkPosInt', u'_CkValidNum', u'_CleanAll', u'_ClearRect', u'_ClearRow', u'_CLine', u'_CLineS', u'_CLN', u'_Clog', u'_CloseEditBuf', u'_CloseEditBufNoR', u'_CloseEdit', u'_CloseProg', u'_ClrGraphRef', u'_ClrLCD', u'_ClrLCDFull', u'_ClrLp', u'_ClrOP1S', u'_ClrOP2S', u'_ClrScrn', u'_ClrScrnFull', u'_ClrTxtShd', u'_CMltByReal', u'_CmpSyms', u'_CMult', u'_Conj', u'_ConvDim', u'_ConvDim00', u'_ConvLcToLr', u'_ConvLrToLc', u'_ConvOP1', u'_COP1Set0', u'_Cos', u'_CosH', u'_CpHLDE', u'_CPoint', u'_CPointS', u'_CpOP1OP2', u'_CpOP4OP3', u'_CpyO1ToFPS1', u'_CpyO1ToFPS2', u'_CpyO1ToFPS3', u'_CpyO1ToFPS4', u'_CpyO1ToFPS5', u'_CpyO1ToFPS6', u'_CpyO1ToFPS7', u'_CpyO1ToFPST', u'_CpyO2ToFPS1', u'_CpyO2ToFPS2', u'_CpyO2ToFPS3', u'_CpyO2ToFPS4', u'_CpyO2ToFPST', u'_CpyO3ToFPS1', u'_CpyO3ToFPS2', u'_CpyO3ToFPST', u'_CpyO5ToFPS1', u'_CpyO5ToFPS3', u'_CpyO6ToFPS2', u'_CpyO6ToFPST', u'_CpyStack', u'_CpyTo1FPS1', u'_CpyTo1FPS10', u'_CpyTo1FPS11', u'_CpyTo1FPS2', u'_CpyTo1FPS3', u'_CpyTo1FPS4', u'_CpyTo1FPS5', u'_CpyTo1FPS6', u'_CpyTo1FPS7', u'_CpyTo1FPS8', u'_CpyTo1FPS9', u'_CpyTo1FPST', u'_CpyTo2FPS1', u'_CpyTo2FPS2', u'_CpyTo2FPS3', u'_CpyTo2FPS4', u'_CpyTo2FPS5', u'_CpyTo2FPS6', u'_CpyTo2FPS7', u'_CpyTo2FPS8', u'_CpyTo2FPST', u'_CpyTo3FPS1', u'_CpyTo3FPS2', u'_CpyTo3FPST', u'_CpyTo4FPST', u'_CpyTo5FPST', u'_CpyTo6FPS2', u'_CpyTo6FPS3', u'_CpyTo6FPST', u'_CpyToFPS1', u'_CpyToFPS2', u'_CpyToFPS3', u'_CpyToFPST', u'_CpyToStack', u'_Create0', u'_CreateAppVar', u'_CreateCList', u'_CreateCplx', u'_Create', u'_CreatePair', u'_CreatePict', u'_CreateProg', u'_CreateProtProg', u'_CreateReal', u'_CreateRList', u'_CreateRMat', u'_CreateStrng', u'_CRecip', u'_CSqRoot', u'_CSquare', u'_CSub', u'_CTenX', u'_CTrunc', u'_Cube', u'_CursorOff', u'_CursorOn', u'_CXrootY', u'_CYtoX', u'_DarkLine', u'_DarkPnt', u'_DataSize', u'_DataSizeA', u'_DeallocFPS', u'_DeallocFPS1', u'_DecO1Exp', u'_DelListEl', u'_DelMem', u'_DelRes', u'_DelVar', u'_DelVarArc', u'_DelVarNoArc', u'_DisableApd', u'_Disp', u'_DispDone', u'_DispEOL', u'_DispHL', u'_DisplayImage', u'_DispMenuTitle', u'_DispOP1A', u'_DivHLBy10', u'_DivHLByA', u'_DrawCirc2', u'_DrawCmd', u'_DrawRectBorder', u'_DrawRectBorderClear', u'_DToR', u'_EditProg', u'_EnableApd', u'_EnoughMem', u'_EOP1NotReal', u'__or_New', u'_EraseEOL', u'_EraseRectBorder', u'_ErrArgument', u'_ErrBadGuess', u'_ErrBreak', u'_ErrD_OP1_0', u'_ErrD_OP1_LE_0', u'_ErrD_OP1Not_R', u'_ErrD_OP1NotPos', u'_ErrD_OP1NotPosInt', u'_ErrDataType', u'_ErrDimension', u'_ErrDimMismatch', u'_ErrDivBy0', u'_ErrDomain', u'_ErrIncrement', u'_ErrInvalid', u'_ErrIterations', u'_ErrLinkXmit', u'_ErrMemory', u'_ErrNon_Real', u'_ErrNonReal', u'_ErrNotEnoughMem', u'_ErrOverflow', u'_ErrSignChange', u'_ErrSingularMat', u'_ErrStat', u'_ErrStatPlot', u'_ErrSyntax', u'_ErrTolTooSmall', u'_ErrUndefined', u'_EToX', u'_Exch9', u'_ExLp', u'_ExpToHex', u'_Factorial', u'_FillRect', u'_FillRectPattern', u'_Find_Parse_Formula', u'_FindAlphaDn', u'_FindAlphaUp', u'_FindApp', u'_FindAppDn', u'_FindAppNumPages', u'_FindAppUp', u'_FindSym', u'_FiveExec', u'_FixTempCnt', u'_FlashToRam', u'_ForceFullScreen', u'_FormBase', u'_FormDCplx', u'_FormEReal', u'_FormReal', u'_FourExec', u'_FPAdd', u'_FPDiv', u'_FPMult', u'_FPRecip', u'_FPSquare', u'_FPSub', u'_Frac', u'_Get_Tok_Strng', u'_GetBaseVer', u'_GetCSC', u'_GetKey', u'_GetLToOP1', u'_GetMToOP1', u'_GetSysInfo ', u'_GetTokLen', u'_GrBufClr', u'_GrBufCpy', u'_GrphCirc', u'_HLTimes9', u'_HorizCmd', u'_HTimesL', u'_IBounds', u'_IBoundsFull', u'_ILine', u'_IncLstSize', u'_InsertList', u'_InsertMem', u'_Int', u'_Intgr', u'_InvCmd', u'_InvertRect', u'_InvOP1S', u'_InvOP1SC', u'_InvOP2S', u'_InvSub', u'_IOffset', u'_IPoint', u'_IsA2ByteTok', u'_IsEditEmpty', u'_JError', u'_JErrorNo', u'_JForceCmdNoChar', u'_JForceGraphKey', u'_JForceGraphNoKey', u'_KeyToString', u'_LCD_BUSY', u'_LCD_DRIVERON', u'_LdHLind', u'_LineCmd', u'_LnX', u'_Load_SFont', u'_LoadCIndPaged', u'_LoadDEIndPaged', u'_LoadPattern', u'_LogX', u'_Max', u'_MemChk', u'_MemClear', u'_MemSet', u'_Min', u'_Minus1', u'_Mov10B', u'_Mov18B', u'_Mov7B', u'_Mov8B', u'_Mov9B', u'_Mov9OP1OP2', u'_Mov9OP2Cp', u'_Mov9ToOP1', u'_Mov9ToOP2', u'_MovFrOP1', u'_NewLine', u'_NZIf83Plus', u'_OneVar', u'_OP1ExOP2', u'_OP1ExOP3', u'_OP1ExOP4', u'_OP1ExOP5', u'_OP1ExOP6', u'_OP1ExpToDec', u'_OP1Set0', u'_OP1Set1', u'_OP1Set2', u'_OP1Set3', u'_OP1Set4', u'_OP1ToOP2', u'_OP1ToOP3', u'_OP1ToOP4', u'_OP1ToOP5', u'_OP1ToOP6', u'_OP2ExOP4', u'_OP2ExOP5', u'_OP2ExOP6', u'_OP2Set0', u'_OP2Set1', u'_OP2Set2', u'_OP2Set3', u'_OP2Set4', u'_OP2Set5', u'_OP2Set60', u'_OP2Set8', u'_OP2SetA', u'_OP2ToOP1', u'_OP2ToOP3', u'_OP2ToOP4', u'_OP2ToOP5', u'_OP2ToOP6', u'_OP3Set0', u'_OP3Set1', u'_OP3Set2', u'_OP3ToOP1', u'_OP3ToOP2', u'_OP3ToOP4', u'_OP3ToOP5', u'_OP4Set0', u'_OP4Set1', u'_OP4ToOP1', u'_OP4ToOP2', u'_OP4ToOP3', u'_OP4ToOP5', u'_OP4ToOP6', u'_OP5ExOP6', u'_OP5Set0', u'_OP5ToOP1', u'_OP5ToOP2', u'_OP5ToOP3', u'_OP5ToOP4', u'_OP5ToOP6', u'_OP6ToOP1', u'_OP6ToOP2', u'_OP6ToOP5', u'_OutputExpr', u'_PagedGet', u'_ParseInp', u'_PDspGrph', u'_PixelTest', u'_Plus1', u'_PointCmd', u'_PointOn', u'_PopMCplxO1', u'_PopOP1', u'_PopOP3', u'_PopOP5', u'_PopReal', u'_PopRealO1', u'_PopRealO2', u'_PopRealO3', u'_PopRealO4', u'_PopRealO5', u'_PopRealO6', u'_PosNo0Int', u'_PToR', u'_PushMCplxO1', u'_PushMCplxO3', u'_PushOP1', u'_PushOP3', u'_PushOP5', u'_PushReal', u'_PushRealO1', u'_PushRealO2', u'_PushRealO3', u'_PushRealO4', u'_PushRealO5', u'_PushRealO6', u'_PutAway', u'_PutC', u'_PutMap', u'_PutPS', u'_PutPSB', u'_PutS', u'_PutTokString', u'_PutToL', u'_PutToMat', u'_RandInit', u'_Random', u'_Rcl_StatVar', u'_RclAns', u'_RclGDB2', u'_RclN', u'_RclSysTok', u'_RclVarSym', u'_RclX', u'_RclY', u'_Rec1stByte', u'_Rec1stByteNC', u'_RecAByteIO', u'_RedimMat', u'_Regraph', u'_ReleaseBuffer', u'_ReloadAppEntryVecs', u'_RestoreDisp', u'_RName', u'_RndGuard', u'_RnFx', u'_Round', u'_RToD', u'_RToP', u'_RunIndicOff', u'_RunIndicOn', u'_SaveDisp', u'_SendAByte', u'_SendVarCmd', u'_SetAllPlots', u'_SetExSpeed ', u'_SetFuncM', u'_SetNorm_Vals', u'_SetParM', u'_SetPolM', u'_SetSeqM', u'_SetTblGraphDraw', u'_SetupPagedPtr', u'_SetXXOP1', u'_SetXXOP2', u'_SetXXXXOP2', u'_SFont_Len', u'_ShRAcc', u'_Sin', u'_SinCosRad', u'_SinH', u'_SinHCosH', u'_SqRoot', u'_SrchVLstDn', u'_SrchVLstUp', u'_SStringLength', u'_StMatEl', u'_StoAns', u'_StoGDB2', u'_StoN', u'_StoOther', u'_StoR', u'_StoRand', u'_StoSysTok', u'_StoT', u'_StoTheta', u'_StoX', u'_StoY', u'_StrCopy', u'_StrLength', u'_Tan', u'_TanH', u'_TanLnF', u'_TenX', u'_ThetaName', u'_ThreeExec', u'_Times2', u'_TimesPt5', u'_TName', u'_ToFrac', u'_Trunc', u'_TwoVarSet', u'_UCLineS', u'_UnLineCmd', u'_UnOPExec', u'_VertCmd', u'_VPutMap', u'_VPutS', u'_VPutSN', u'_VtoWHLDE', u'_XftoI', u'_Xitof', u'_XName', u'_XRootY', u'_YftoI', u'_YName', u'_YToX', u'_Zero16D', u'_ZeroOP', u'_ZeroOP1', u'_ZeroOP2', u'_ZeroOP3', u'_ZmDecml', u'_ZmFit', u'_ZmInt', u'_ZmPrev', u'_ZmSquare', u'_ZmStats', u'_ZmTrig', u'_ZmUsr', u'_ZooDefault']
	
	opcodes = ['00','01','02','03','04','05','06','07','08','09','0A','0B','0C','0D','0E','0F','10','11','12','13','14','15','16','17','18','19','1A','1B','1C','1D','1E','1F','20','21','22','23','24','25','26','27','28','29','2A','2B','2C','2D','2E','2F','30','31','32','33','34','35','36','37','38','39','3A','3B','3C','3D','3E','3F','40','41','42','43','44','45','46','47','48','49','4A','4B','4C','4D','4E','4F','50','51','52','53','54','55','56','57','58','59','5A','5B','5C','5D','5E','5F','60','61','62','63','64','65','66','67','68','69','6A','6B','6C','6D','6E','6F','70','71','72','73','74','75','76','77','78','79','7A','7B','7C','7D','7E','7F','80','81','82','83','84','85','86','87','88','89','8A','8B','8C','8D','8E','8F','90','91','92','93','94','95','96','97','98','99','9A','9B','9C','9D','9E','9F','A0','A1','A2','A3','A4','A5','A6','A7','A8','A9','AA','AB','AC','AD','AE','AF','B0','B1','B2','B3','B4','B5','B6','B7','B8','B9','BA','BB','BC','BD','BE','BF','C0','C1','C2','C3','C4','C5','C6','C7','C8','C9','CA','CB','CC','CD','CE','CF','D0','D1','D2','D3','D4','D5','D6','D7','D8','D9','DA','DB','DC','DD','DE','DF','E0','E1','E2','E3','E4','E5','E6','E7','E8','E9','EA','EB','EC','ED','EE','EF','F0','F1','F2','F3','F4','F5','F6','F7','F8','F9','FA','FB','FC','FD','FE','FF']
	opcodesAssembly = ['nop','ld bc,','ld (bc),a','inc bc','inc b','dec b','ld b,','rlca','ex af,af','add hl,bc','ld a,(bc)','dec bc','inc c','dec c','ld c,','rrca','djnz ','ld de,','ld (de),a','inc de','inc d','dec d','ld d,','rla','jr ','add hl,de','ld a,(de)','dec de','inc e','dec e','ld e,','rra','jr nz,','ld hl,','ld(),hl','inc hl','inc h','dec h','ld h,','daa','jr z,','add hl,hl','ld hl,()','dec hl','inc l','dec l','ld l,','cpl','jr nc, ','ld sp,','ld(),a','inc sp','inc (hl)','dec (hl)','ld (hl),','scf','jr c, ','add hl,sp','ld a,()','dec sp','inc a','dec a','ld a,','ccf','ld b,b','	ld b,c','ld b,d','ld b,e','ld b,h','ld b,l','ld b,(hl)','ld b,a','ld c,b','ld c,c','ld c,d','ld c,e','ld c,h','ld c,l','ld c,(hl)','ld c,a','ld d,b','ld d,c','ld d,d','ld d,e','ld d,h','ld d,l','ld d,(hl)','	ld d,a','ld e,b','ld e,c','ld e,d','ld e,e','ld e,h	','ld e,l','ld e,(hl)','ld e,a','ld h,b','	ld h,c','ld h,d','ld h,e','ld h,h','ld h,l','ld h,(hl)','ld h,a','ld l,b','ld l,c','ld l,d','ld l,e','ld l,h','ld l,l','lh l,(hl)','ld l,a','ld (hl),b','ld (hl),c','ld (hl),d','ld (hl),e','ld (hl),h','ld (hl),l','halt','ld (hl),a','ld a,b','ld a,c','ld a,d','ld a,e','ld a,h','ld a,l','ld a,(hl)','ld a,a','add a,b','add a,c','add a,d','add a,e','add a,h','add a,l','add a,(hl)','add a,a','adc a,b','adc a,c','adc a,d','adc a,e','adc a,h','adc a,l','adc a,(hl)','adc a,a','sub b','sub c','sub d','sub e','sub h','sub l','sub (hl)','sub a','sbc a,b','sbc a,c','abc a,d','sbc a,e','sbc a,h','sbc a,l','sbc a,(hl)','sbc a,a','and b','and c','and d','and e','and h','and l','and (hl)','and a','xor b','xor c','xor d','xor e','xor h','xor l','xor (hl)','xor a','or b','or c','or d','or e','or h','or l','or (hl)','or a','cp b','cp c','cp d','cp e','cp h','cp l','cp (hl)','cp a','ret nz','pop bc','jp nz,','jp ','call nz,','push bc','add a,','rst 00h','ret z','ret','jp z, ','XX','call z,','call ','adc a,','rst 08h','ret nc','pop de','jp nc,','out (),a','call nc,','push de','sub ','rst 10h','ret c','exx','jp c,','in a,()','call c,','XX','sbc a,','rst 18h','ret po','pop hl','jp po,','ex (sp),hl','call po,','push hl','and ','rst 20h','ret pe','jp (hl)','jp pe,','ex de,hl','call pe,','XX','xor ','rst 28h','ret p','pop af','jp p,','di','call p,','push af','or ','rst 30h','ret m','ld sp,hl','jp m,','ei','call m,','XX','cp ','rst 38h']																
	
	opcodesAssemblyDDCB = ['rlc (ix+),b','rlc (ix+),c','rlc (ix+),d','rlc (ix+),e','rlc (ix+),h','rlc (ix+),l','rlc (ix+)','rlc (ix+),a','rrc (ix+),b','rrc (ix+),c','rrc (ix+),d','rrc (ix+),e','rrc (ix+),h','rrc (ix+),l','rrc (ix+)','rrc (ix+),a','rl (ix+),b','rl (ix+),c','rl (ix+),d','rl (ix+),e','rl (ix+),h','rl (ix+),l','rl (ix+)','rl (ix+),a','rr (ix+),b','rr (ix+),c','rr (ix+),d','rr (ix+),e','rr (ix+),h','rr (ix+),l','rr (ix+)','rr (ix+),a','sla (ix+),b','sla (ix+),c','sla (ix+),d','sla (ix+),e','sla (ix+),h','sla (ix+),l','sla (ix+)','sla (ix+),a','sra (ix+),b','sra (ix+),c','sra (ix+),d','sra (ix+),e','sra (ix+),h','sra (ix+),l','sra (ix+)','sra (ix+),a','sll (ix+),b','sll (ix+),c','sll (ix+),d','sll (ix+),e','sll (ix+),h','sll (ix+),l','sll (ix+)','sll (ix+),a','srl (ix+),b','srl (ix+),c','srl (ix+),d','srl (ix+),e','srl (ix+),h','srl (ix+),l','	srl (ix+)','srl (ix+),a','bit 0,(ix+)','bit 0,(ix+)','bit 0,(ix+)','bit 0,(ix+)','bit 0,(ix+)','bit 0,(ix+)','bit 0,(ix+)','bit 1,(ix+)','bit 1,(ix+)','bit 1,(ix+)','bit 1,(ix+)','bit 1,(ix+)','bit 1,(ix+)','bit 1,(ix+)','bit 1,(ix+)','bit 1,(ix+)','bit 2,(ix+)','bit 2,(ix+)','bit 2,(ix+)','bit 2,(ix+)','bit 2,(ix+)','bit 2,(ix+)','bit 2,(ix+)','bit 2,(ix+)','bit 3,(ix+)','bit 3,(ix+)','bit 3,(ix+)','bit 3,(ix+)','bit 3,(ix+)','bit 3,(ix+)','bit 3,(ix+)','bit 3,(ix+)','bit 4,(ix+)','bit 4,(ix+)','bit 4,(ix+)','bit 4,(ix+)','bit 4,(ix+)','bit 4,(ix+)','bit 4,(ix+)','bit 4,(ix+)','bit 5,(ix+)','bit 5,(ix+)','bit 5,(ix+)','bit 5,(ix+)','bit 5,(ix+)','bit 5,(ix+)','bit 5,(ix+)','bit 5,(ix+)','bit 6,(ix+)','bit 6,(ix+)','bit 6,(ix+)','bit 6,(ix+)','bit 6,(ix+)','bit 6,(ix+)','bit 6,(ix+)','bit 6,(ix+)','bit 7,(ix+)','bit 7,(ix+)','bit 7,(ix+)','bit 7,(ix+)','bit 7,(ix+)','bit 7,(ix+)','bit 7,(ix+)','bit 7,(ix+)','res 0,(ix+),b','res 0,(ix+),c','res 0,(ix+),d','res 0,(ix+),e','res 0,(ix+),h','res 0,(ix+),l','res 0,(ix+)','res 0,(ix+),a','res 1,(ix+),b','res 1,(ix+),c','res 1,(ix+),d','res 1,(ix+),e','res 1,(ix+),h','res 1,(ix+),l','res 1,(ix+)','res 1,(ix+),a','res 2,(ix+),b','res 2,(ix+),c','res 2,(ix+),d','res 2,(ix+),e','res 2,(ix+),h','res 2,(ix+),l','res 2,(ix+)','res 2,(ix+),a','res 3,(ix+),b','res 3,(ix+),c','res 3,(ix+),d','res 3,(ix+),e','res 3,(ix+),h','res 3,(ix+),l','res 3,(ix+)','res 3,(ix+),a','res 4,(ix+),b','res 4,(ix+),c','res 4,(ix+),d','res 4,(ix+),e','res 4,(ix+),h','res 4,(ix+),l','res 4,(ix+)','res 4,(ix+),a','res 5,(ix+),b','res 5,(ix+),c','res 5,(ix+),d','res 5,(ix+),e','res 5,(ix+),h','res 5,(ix+),l','res 5,(ix+)','res 5,(ix+),a','res 6,(ix+),b','res 6,(ix+),c','res 6,(ix+),d','res 6,(ix+),e','res 6,(ix+),h','res 6,(ix+),l','res 6,(ix+)','res 6,(ix+),a','res 7,(ix+),b','res 7,(ix+),c','res 7,(ix+),d','res 7,(ix+),e','res 7,(ix+),h','res 7,(ix+),l','res 7,(ix+)','res 7,(ix+),a','set 0,(ix+),b','set 0,(ix+),c','set 0,(ix+),d','set 0,(ix+),e','set 0,(ix+),h','set 0,(ix+),l','set 0,(ix+)','set 0,(ix+),a','set 1,(ix+),b','set 1,(ix+),c','set 1,(ix+),d','set 1,(ix+),e','set 1,(ix+),h','set 1,(ix+),l','set 1,(ix+)','set 1,(ix+),a','set 2,(ix+),b','set 2,(ix+),c','set 2,(ix+),d','set 2,(ix+),e','set 2,(ix+),h','set 2,(ix+),l','set 2,(ix+)','set 2,(ix+),a','set 3,(ix+),b','set 3,(ix+),c','set 3,(ix+),d','set 3,(ix+),e','set 3,(ix+),h','set 3,(ix+),l','set 3,(ix+)','set 3,(ix+),a','set 4,(ix+),b','set 4,(ix+),c','set 4,(ix+),d','set 4,(ix+),e','set 4,(ix+),h','set 4,(ix+),l','set 4,(ix+)','set 4,(ix+),a','set 5,(ix+),b','set 5,(ix+),c','set 5,(ix+),d','set 5,(ix+),e','set 5,(ix+),h','set 5,(ix+),l','set 5,(ix+)','set 5,(ix+),a','set 6,(ix+),b','set 6,(ix+),c','set 6,(ix+),d','set 6,(ix+),e','set 6,(ix+),h','set 6,(ix+),l','set 6,(ix+)','set 6,(ix+),a','set 7,(ix+),b','set 7,(ix+),c','set 7,(ix+),d','set 7,(ix+),e','set 7,(ix+),h','set 7,(ix+),l','set 7,(ix+)','set 7,(ix+),a']
	
	opcodesAssemblyFDCB = ['rlc (iy+),b','rlc (iy+),c','rlc (iy+),d','rlc (iy+),e','rlc (iy+),h','rlc (iy+),l','rlc (iy+)','rlc (iy+),a','rrc (iy+),b','rrc (iy+),c','rrc (iy+),d','rrc (iy+),e','rrc (iy+),h','rrc (iy+),l','rrc (iy+)','rrc (iy+),a','rl (iy+),b','rl (iy+),c','rl (iy+),d','rl (iy+),e','rl (iy+),h','rl (iy+),l','rl (iy+)','rl (iy+),a','rr (iy+),b','rr (iy+),c','rr (iy+),d','rr (iy+),e','rr (iy+),h','rr (iy+),l','rr (iy+)','rr (iy+),a','sla (iy+),b','sla (iy+),c','sla (iy+),d','sla (iy+),e','sla (iy+),h','sla (iy+),l','sla (iy+)','sla (iy+),a','sra (iy+),b','sra (iy+),c','sra (iy+),d','sra (iy+),e','sra (iy+),h','sra (iy+),l','sra (iy+)','sra (iy+),a','sll (iy+),b','sll (iy+),c','sll (iy+),d','sll (iy+),e','sll (iy+),h','sll (iy+),l','sll (iy+)','sll (iy+),a','srl (iy+),b','srl (iy+),c','srl (iy+),d','srl (iy+),e','srl (iy+),h','srl (iy+),l','	srl (iy+)','srl (iy+),a','bit 0,(iy+)','bit 0,(iy+)','bit 0,(iy+)','bit 0,(iy+)','bit 0,(iy+)','bit 0,(iy+)','bit 0,(iy+)','bit 1,(iy+)','bit 1,(iy+)','bit 1,(iy+)','bit 1,(iy+)','bit 1,(iy+)','bit 1,(iy+)','bit 1,(iy+)','bit 1,(iy+)','bit 1,(iy+)','bit 2,(iy+)','bit 2,(iy+)','bit 2,(iy+)','bit 2,(iy+)','bit 2,(iy+)','bit 2,(iy+)','bit 2,(iy+)','bit 2,(iy+)','bit 3,(iy+)','bit 3,(iy+)','bit 3,(iy+)','bit 3,(iy+)','bit 3,(iy+)','bit 3,(iy+)','bit 3,(iy+)','bit 3,(iy+)','bit 4,(iy+)','bit 4,(iy+)','bit 4,(iy+)','bit 4,(iy+)','bit 4,(iy+)','bit 4,(iy+)','bit 4,(iy+)','bit 4,(iy+)','bit 5,(iy+)','bit 5,(iy+)','bit 5,(iy+)','bit 5,(iy+)','bit 5,(iy+)','bit 5,(iy+)','bit 5,(iy+)','bit 5,(iy+)','bit 6,(iy+)','bit 6,(iy+)','bit 6,(iy+)','bit 6,(iy+)','bit 6,(iy+)','bit 6,(iy+)','bit 6,(iy+)','bit 6,(iy+)','bit 7,(iy+)','bit 7,(iy+)','bit 7,(iy+)','bit 7,(iy+)','bit 7,(iy+)','bit 7,(iy+)','bit 7,(iy+)','bit 7,(iy+)','res 0,(iy+),b','res 0,(iy+),c','res 0,(iy+),d','res 0,(iy+),e','res 0,(iy+),h','res 0,(iy+),l','res 0,(iy+)','res 0,(iy+),a','res 1,(iy+),b','res 1,(iy+),c','res 1,(iy+),d','res 1,(iy+),e','res 1,(iy+),h','res 1,(iy+),l','res 1,(iy+)','res 1,(iy+),a','res 2,(iy+),b','res 2,(iy+),c','res 2,(iy+),d','res 2,(iy+),e','res 2,(iy+),h','res 2,(iy+),l','res 2,(iy+)','res 2,(iy+),a','res 3,(iy+),b','res 3,(iy+),c','res 3,(iy+),d','res 3,(iy+),e','res 3,(iy+),h','res 3,(iy+),l','res 3,(iy+)','res 3,(iy+),a','res 4,(iy+),b','res 4,(iy+),c','res 4,(iy+),d','res 4,(iy+),e','res 4,(iy+),h','res 4,(iy+),l','res 4,(iy+)','res 4,(iy+),a','res 5,(iy+),b','res 5,(iy+),c','res 5,(iy+),d','res 5,(iy+),e','res 5,(iy+),h','res 5,(iy+),l','res 5,(iy+)','res 5,(iy+),a','res 6,(iy+),b','res 6,(iy+),c','res 6,(iy+),d','res 6,(iy+),e','res 6,(iy+),h','res 6,(iy+),l','res 6,(iy+)','res 6,(iy+),a','res 7,(iy+),b','res 7,(iy+),c','res 7,(iy+),d','res 7,(iy+),e','res 7,(iy+),h','res 7,(iy+),l','res 7,(iy+)','res 7,(iy+),a','set 0,(iy+),b','set 0,(iy+),c','set 0,(iy+),d','set 0,(iy+),e','set 0,(iy+),h','set 0,(iy+),l','set 0,(iy+)','set 0,(iy+),a','set 1,(iy+),b','set 1,(iy+),c','set 1,(iy+),d','set 1,(iy+),e','set 1,(iy+),h','set 1,(iy+),l','set 1,(iy+)','set 1,(iy+),a','set 2,(iy+),b','set 2,(iy+),c','set 2,(iy+),d','set 2,(iy+),e','set 2,(iy+),h','set 2,(iy+),l','set 2,(iy+)','set 2,(iy+),a','set 3,(iy+),b','set 3,(iy+),c','set 3,(iy+),d','set 3,(iy+),e','set 3,(iy+),h','set 3,(iy+),l','set 3,(iy+)','set 3,(iy+),a','set 4,(iy+),b','set 4,(iy+),c','set 4,(iy+),d','set 4,(iy+),e','set 4,(iy+),h','set 4,(iy+),l','set 4,(iy+)','set 4,(iy+),a','set 5,(iy+),b','set 5,(iy+),c','set 5,(iy+),d','set 5,(iy+),e','set 5,(iy+),h','set 5,(iy+),l','set 5,(iy+)','set 5,(iy+),a','set 6,(iy+),b','set 6,(iy+),c','set 6,(iy+),d','set 6,(iy+),e','set 6,(iy+),h','set 6,(iy+),l','set 6,(iy+)','set 6,(iy+),a','set 7,(iy+),b','set 7,(iy+),c','set 7,(iy+),d','set 7,(iy+),e','set 7,(iy+),h','set 7,(iy+),l','set 7,(iy+)','set 7,(iy+),a']

	opcodesAssemblyDD = ['nop','nop','nop','nop','nop','nop','nop','nop','nop','add ix,bc','nop','nop','nop','nop','nop','nop','nop','nop','nop','nop','nop','nop','nop','nop','nop','add ix,de','nop','nop','nop','nop','nop','nop','nop','ld ix,','ld (),ix','inc ix','inc ixh','dec ixh','ld ixh,','nop','nop','add ix,ix','ld ix,()','dec ix','inc ixl','dec ixl','ld ixl,','nop','nop','nop','nop','nop','inc (ix+)','dec (ix+)','ld (ix+),','nop','nop','add ix,sp','nop','nop','nop','nop','nop','nop','nop','nop','nop','nop','ld b,ixh','ld b,ixl','ld b,(ix+)','nop','nop','nop','nop','nop','ld c,ixh','ld c,ixl','ld c,(ix+)','nop','nop','nop','nop','nop','ld d,ixh','ld d,ixl','ld d,(ix+)','nop','nop','nop','nop','nop','ld e,ixh','ld e,ixl','ld e,(ix+)','nop','d ixh,b','ld ixh,c','ld ixh,d','ld ixh,e','ld ixh,ixh','ld ixh,ixl','ld h,(ix+)','ld ixh,a','ld ixl,b','ld ixl,c','ld ixl,d','ld ixl,e','ld ixl,ixh','ld ixl,ixl','lh l,(ix+)','ld ixl,a','ld (ix+),b','ld (ix+),c','ld (ix+),d','ld (ix+),e','ld (ix+),h','ld (ix+),l','nop','ld (ix+),a','nop','nop','nop','nop','ld a,ixh','ld a,ixl','ld a,(ix+)','nop','nop','nop','nop','nop','add a,ixh','add a,ixl','add a,(ix+)','nop','nop','nop','nop','nop','adc a,ixh','adc a,ixl','adc a,(ix+)','nop','nop','nop','nop','nop','sub ixh','sub ixl','sub (ix+)','nop','nop','nop','nop','nop','sbc a,ixh','sbc a,ixl','sbc a,(ix+)','nop','nop','nop','nop','nop','and ixh','and ixl','and (ix+)','nop','nop','nop','nop','nop','xor ixh','xor ixl','xor (ix+)','nop','nop','nop','nop','nop','or ixh','or ixl','or (ix+)','nop','nop','nop','nop','nop','cp ixh','cp ixl','cp (ix+)','nop','nop','nop','nop','nop','nop','nop','nop','nop','nop','nop','nop','XX','nop','nop','nop','nop','nop','nop','nop','nop','nop','nop','nop','nop','nop','nop','nop','nop','nop','nop','nop','nop','nop','pop ix','nop','ex (sp),ix','nop','push ix','nop','nop','nop','jp (ix','nop','nop','nop','nop','nop','nop','nop','nop','nop','nop','nop','nop','nop','nop','nop','ld sp,ix','nop','nop','nop','nop','nop','nop']
	opcodesAssemblyFD = ['nop','nop','nop','nop','nop','nop','nop','nop','nop','add iy,bc','nop','nop','nop','nop','nop','nop','nop','nop','nop','nop','nop','nop','nop','nop','nop','add iy,de','nop','nop','nop','nop','nop','nop','nop','ld iy,','ld (),iy','inc iy','inc iyh','dec iyh','ld iyh,','nop','nop','add iy,iy','ld iy,()','dec iy','inc iyl','dec iyl','ld iyl,','nop','nop','nop','nop','nop','inc (iy+)','dec (iy+)','ld (iy+),','nop','nop','add iy,sp','nop','nop','nop','nop','nop','nop','nop','nop','nop','nop','ld b,iyh','ld b,iyl','ld b,(iy+)','nop','nop','nop','nop','nop','ld c,iyh','ld c,iyl','ld c,(iy+)','nop','nop','nop','nop','nop','ld d,iyh','ld d,iyl','ld d,(iy+)','nop','nop','nop','nop','nop','ld e,iyh','ld e,iyl','ld e,(iy+)','nop','d iyh,b','ld iyh,c','ld iyh,d','ld iyh,e','ld iyh,iyh','ld iyh,iyl','ld h,(iy+)','ld iyh,a','ld iyl,b','ld iyl,c','ld iyl,d','ld iyl,e','ld iyl,iyh','ld iyl,iyl','lh l,(iy+)','ld iyl,a','ld (iy+),b','ld (iy+),c','ld (iy+),d','ld (iy+),e','ld (iy+),h','ld (iy+),l','nop','ld (iy+),a','nop','nop','nop','nop','ld a,iyh','ld a,iyl','ld a,(iy+)','nop','nop','nop','nop','nop','add a,iyh','add a,iyl','add a,(iy+)','nop','nop','nop','nop','nop','adc a,iyh','adc a,iyl','adc a,(iy+)','nop','nop','nop','nop','nop','sub iyh','sub iyl','sub (iy+)','nop','nop','nop','nop','nop','sbc a,iyh','sbc a,iyl','sbc a,(iy+)','nop','nop','nop','nop','nop','and iyh','and iyl','and (iy+)','nop','nop','nop','nop','nop','xor iyh','xor iyl','xor (iy+)','nop','nop','nop','nop','nop','or iyh','or iyl','or (iy+)','nop','nop','nop','nop','nop','cp iyh','cp iyl','cp (iy+)','nop','nop','nop','nop','nop','nop','nop','nop','nop','nop','nop','nop','XX','nop','nop','nop','nop','nop','nop','nop','nop','nop','nop','nop','nop','nop','nop','nop','nop','nop','nop','nop','nop','nop','pop iy','nop','ex (sp),iy','nop','push iy','nop','nop','nop','jp (iy','nop','nop','nop','nop','nop','nop','nop','nop','nop','nop','nop','nop','nop','nop','nop','ld sp,iy','nop','nop','nop','nop','nop','nop']
	
	opcodesAssemblyCB = ['rlc b','rlc c','rlc d','rlc e','rlc h','rlc l','rlc (hl)','rlc a','rrc b','rrc c','rrc d','rrc e','rrc h','rrc l','rrc (hl)','rrc a','rl b','rl c','rl d','rl e','rl h','rl l','rl (hl)','rl a','rr b','rr c','rr d','rr e','rr h','rr l','rr (hl)','rr a','sla b','sla c','sla d','sla e','sla h','sla l','sla (hl)','sla a','sra b','sra c','sra d','sra e','sra h','sra l','sra (hl)','sra a','sll b','sll c','sll d','sll e','sll h','sll l','sll (hl)','	sll a','srl b','srl c','srl d','srl e','srl h','srl l','srl (hl)','srl a','bit 0,b','bit 0,c','bit 0,d','bit 0,e','bit 0,h','bit 0,l','bit 0,(hl)','bit 0,a','bit 1,b','bit 1,c','bit 1,d','bit 1,e','bit 1,h','bit 1,l','bit 1,(hl)','bit 1,a','bit 2,b','	bit 2,c','	bit 2,d','bit 2,e','bit 2,h','bit 2,l','bit 2,(hl)','bit 2,a','bit 3,b','bit 3,c','bit 3,d','bit 3,e','bit 3,h','bit 3,l','bit 3,(hl)','bit 3,a','bit 4,b','bit 4,c','bit 4,d','bit 4,e','bit 4,h','bit 4,l','bit 4,(hl)','bit 4,a','bit 5,b','bit 5,c','bit 5,d','bit 5,e','bit 5,h','bit 5,l','bit 5,(hl)','bit 5,a','bit 6,b','bit 6,c','bit 6,d','bit 6,e','bit 6,h','bit 6,l','bit 6,(hl)','bit 6,a','	bit 7,b','bit 7,c','bit 7,d','bit 7,e','bit 7,h','bit 7,l','bit 7,(hl)','bit 7,a','res 0,b','res 0,c','res 0,d','res 0,e','res 0,h','res 0,l','res 0,(hl)','res 0,a','res 1,b','res 1,c','res 1,d','res 1,e','res 1,h','res 1,l','res 1,(hl)','res 1,a','res 2,b','res 2,c','res 2,d','res 2,e','res 2,h','res 2,l','res 2,(hl)','res 2,a','res 3,b','res 3,c','res 3,d','res 3,e','res 3,h','res 3,l','res 3,(hl)','res 3,a','res 4,b','res 4,c','res 4,d','res 4,e','res 4,h','res 4,l','res 4,(hl)','res 4,a','res 5,b','res 5,c','res 5,d','res 5,e','res 5,h','res 5,l','res 5,(hl)','res 5,a','res 6,b','res 6,c','res 6,d','res 6,e','res 6,h','res 6,l','res 6,(hl)','res 6,a','res 7,b','res 7,c','res 7,d','res 7,e','res 7,h','res 7,l','res 7,(hl)','res 7,a','set 0,b','set 0,c','set 0,d','set 0,e','set 0,h','set 0,l','set 0,(hl)','set 0,a','set 1,b','set 1,c','set 1,d','set 1,e','set 1,h','set 1,l','set 1,(hl)','set 1,a','set 2,b','set 2,c','set 2,d','set 2,e','set 2,h','set 2,l','set 2,(hl)','set 2,a','set 3,b','set 3,c','set 3,d','set 3,e','set 3,h','set 3,l','set 3,(hl)','set 3,a','set 4,b','set 4,c','set 4,d','set 4,e','set 4,h','set 4,l','set 4,(hl)','set 4,a','set 5,b','set 5,c','set 5,d','set 5,e','set 5,h','set 5,l','set 5,(hl)','set 5,a','set 6,b','set 6,c','set 6,d','set 6,e','set 6,h','set 6,l','set 6,(hl)','set 6,a','set 7,b','set 7,c','set 7,d','set 7,e','set 7,h','set 7,l','set 7,(hl)','set 7,a']
	opcodesDE = ['40','41','42','43','44','45','46','47','48','49','4A','4B','4C','4D','4E','4F','50','51','52','53','54','55','56','57','58','59','5A','5B','5C','5D','5E','5F','60','61','62','63','64','65','66','67','68','69','6A','6B','6C','6D','6E','6F','70','71','72','73','74','75','76','77','78','79','7A','7B','7C','7D','7E','7F','A0','A1','A2','A3','A4','A5','A6','A7','A8','A9','AA','AB','AC','AD','AE','AF','B0','B1','B2','B3','B4','B5','B6','B7','B8','B9','BA','BB','BC','BD','BE','BF']
	opcodesAssemblyDE = ['in b,(c)','out (c),b','sbc hl,bc','ld (),bc','neg','retn','im 0','ld i,a','in c,(c)','out (c),c','adc hl,bc','ld bc,()','neg','reti','im 0','ld r,a','in d,(c)','out (c),d','sbc hl,de','ld (),de','neg','retn','im 1','ld a,i','in e,(c)','out (c),e','adc hl,de','ld de,()','neg','retn','im 2','ld a,r','in h,(c)','out (c),h','sbc hl,hl','ld (),hl','neg','retn','im 0','rrd','in l,(c)','out (c),l','adc hl,hl','ld hl,()','neg','retn','im 0','rld','in (c)','out (c),0','sbc hl,sp','ld (),sp','neg','retn','	im 1','nop','in a,(c)','out (c),a','adc hl,sp','ld sp,()','neg','retn','im 2','nop','ldi','cpi','ini','outi','nop','nop','nop','nop','ldd','cpd','ind','outd','nop','nop','nop','nop','ldir','cpir','inir','otir','nop','nop','nop','nop','lddr','cpdr','indr','otdr','nop','nop','nop','nop']
	doubleAsterisk = ['01','21','01','11','21','31','C4','CC','CD','D4','DB','DC','E4','EC','F4','F9','FC'] 
	singleAsterisk = ['26','2E','06','0E','16','18','1E','10','20','26','28','2E','30','36','38','3E','C6','CE','D6','DE','E6','EE','F6','FE']
	
	special1 = ['22','32']
	special2 = ['2A']
	special3 = ['3A']
	special4 = ['D3']
	special5 = ['DB']
	labels1 = ['10','20','30','18','28','38']
	labels2 = ['C2','D2','E2','F2','C3','CA','DA','EA','FA']
	
	special101 = ['43','53','63','73']
	special102 = ['4B','5B','6B','7B']
	
	doubleAsteriskIX = ['21']
	singleAsteriskIX = ['2E','26']
	special1IX = ['22']
	special2IX = ['2A']
	special3IX = ['34','35']
	special4IX = ['36']
	special5IX = ['46','56','66','4E','5E','6E','7E']
	special6IX = ['70','71','72','73','74','75','77','B6','BE']
	special7IX = ['86','8E','9E']
	special8IX = ['96','A6','AE']
	
	groupBits7 = ['10','11','12','13','14','15','16','17','18','19','1A','1B','1C','1D','1E','1F']
	groupBits8 = ['00','01','02','03','04','05','06','07','08','09','0A','0B','0C','0D','0E','0F','20','21','22','23','24','25','26','27','28','29','2A','2B','2C','2D','2E','2F','30','31','32','33','34','35','36','37','38','39','3A','3B','3C','3D','3E','3F']
	groupBits10 = ['40','41','42','43','44','45','46','47','48','49','4A','4B','4C','4D','4E','4F','50','51','52','53','54','55','56','57','58','59','5A','5B','5C','5D','5E','5F','60','61','62','63','64','65','66','67','68','69','6A','6B','6C','6D','6E','6F','70','71','72','73','74','75','76','77','78','79','7A','7B','7C','7D','7E','7F','80','81','82','83','84','85','86','87','88','89','8A','8B','8C','8D','8E','8F','90','91','92','93','94','95','96','97','98','99','9A','9B','9C','9D','9E','9F','A0','A1','A2','A3','A4','A5','A6','A7','A8','A9','AA','AB','AC','AD','AE','AF','B0','B1','B2','B3','B4','B5','B6','B7','B8','B9','BA','BB','BC','BD','BE','BF','C0','C1','C2','C3','C4','C5','C6','C7','C8','C9','CA','CB','CC','CD','CE','CF','D0','D1','D2','D3','D4','D5','D6','D7','D8','D9','DA','DB','DC','DD','DE','DF','E0','E1','E2','E3','E4','E5','E6','E7','E8','E9','EA','EB','EC','ED','EE','EF','F0','F1','F2','F3','F4','F5','F6','F7','F8','F9','FA','FB','FC','FD','FE','FF']
	
	#END OF PRECIOUS ARRAYS
	
	
	#START OF GUI
	panel = wx.Panel(self,size=(1366,768))
	
	self.inputText = wx.TextCtrl(panel,size=(715,665),style=wx.TE_MULTILINE | wx.BORDER_SUNKEN)

	self.outputText = wx.TextCtrl(panel,size=(715,665),style=wx.TE_MULTILINE | wx.BORDER_SUNKEN)
	
	vbox = wx.BoxSizer(wx.VERTICAL)
	hbox = wx.BoxSizer() #wx.VERTICAL or DEFAULT = wx.HORIZONTAL

	hbox.Add(self.inputText,1,wx.EXPAND)
	hbox.Add(self.outputText,1,wx.EXPAND)

	vbox.Add((0,0))
	vbox.Add(hbox,50,wx.CENTER|wx.EXPAND)

	self.SetSizer(vbox)
	
	global ID_CONVERT
	ID_CONVERT = 101
	
	self.statusbar = self.CreateStatusBar()
	self.statusbar.SetFieldsCount(3)
	self.statusbar.SetStatusWidths([-5, -2, -1])
		
	menuBar=wx.MenuBar()
	file=wx.Menu()
	newFileOption = file.Append(7,"New\tCtrl+N","Opens New File")
	
	openMenu = wx.Menu()
	
	dissambleFileOption = openMenu.Append(22,"Load .8xp\tF6","Dissambles a .8xp file")
	openHEXOption = openMenu.Append(6,"Open Hex\tCtrl+O","Opens an Hexadecimal code")
	
	file.AppendMenu(-1,"Open",openMenu)
	
	saveMenu = wx.Menu()
	
	saveASMOption = saveMenu.Append(3,"Save Assembly\tCtrl+S","Saves the Assembly File")
	saveHEXOption = saveMenu.Append(4,"Save Hex","Saves the Hexadecimal File")
	saveASMHEXOption = saveMenu.Append(8,"Save Hex and Asm","Saves the Assembly and the Hexadecimal code in one file")
	save8xpOption = saveMenu.Append(25,"Export to 8xp\tCtrl+E","Exports the code to a 8xp file")
	
	file.AppendMenu(-1,"Save",saveMenu)
	
	exitAction = file.Append(5,"Exit\tAlt+F4","Quits Assemblex")
	edit = wx.Menu()
	undo = edit.Append(14,'Undo\tCtrl+Z','Goes back in time')
	redo = edit.Append(15,'Redo\tCtrl+Y','Goes ahead in time')
	edit.AppendSeparator()
	findReplaceOption = edit.Append(20,'Find and Replace\tCtrl+F','Finds and replaces text in the code')
	edit.AppendSeparator()
	selectAll = edit.Append(9,'Select All\tCtrl+A', 'Selects all the text')
	edit.AppendSeparator()
	cut = edit.Append(10,'Cut\tCtrl+X','Cuts the selected text')
	copy = edit.Append(11,'Copy\tCtrl+C','Cuts the selected text')
	paste = edit.Append(12,'Paste\tCtrl+V','Pastes the copied text')
	edit.AppendSeparator()
	lengthOption = edit.Append(23,'Words','Counts the number of characters and words')
	clear = edit.Append(13,'Clear','Deletes the whole text')
	
	
	
	convert=wx.Menu()
	disassembleOption = convert.Append(1,"Convert\tF5","Converts Hexadecimal to Assembly")
	tools=wx.Menu()
	numToHexOption = tools.Append(18,'Decimal to Hexadecimal','Converts a decimal number to Hexadecimal')
	hexToNumOption = tools.Append(19,'Hexadecimal to Decimal','Converts Hexadecimal code to a decimal number')
	help = wx.Menu()
	aboutOption = help.Append(2,"About","Information about Assemblex")
	onlineHelpOption = help.Append(24,"Online help","Get online help at cemetech.net and omnimaga.org")
	menuBar.Append(file,"File")
	menuBar.Append(edit,"Edit")
	menuBar.Append(convert,"Convert")
	menuBar.Append(tools,"Tools")
	menuBar.Append(help,"Help")
	self.SetMenuBar(menuBar)
	
	
	global i
	
	def OnUpdateInputText(event):
		c = self.inputText.GetValue()
		d = c.replace('\n', '')
		e = d.replace('\r','')
		a = e.upper()
		anum = len(a) 
		
		
		if check_validity(a):
		
			if a=="":
				self.outputText.SetValue("")
			elif a == a.upper():
				if anum%2==0:
					
					b = [a[x:x+2] for x in xrange(0,len(a),2)] #Split it into groups of bytes
					
					program = ""
					i=0
					while i < anum-1:
						if (b[i] in opcodes)==True:
							opcodeLocation=opcodes.index(b[i])
							
							"""#if len(b) % 3==0:
								#bCallUsed = ''.join([b[i],b[i+1],b[i+2]])
								if bCallUsed in bCallsCode:
									bCallLocation = bCallsCode.index(bCallUsed)
									if i != 0:
										program += "\n"+ "B_CALL("+bCallsName[bCallLocation]+")"   
									else:
										program += "B_CALL("+bCallsName[bCallLocation]+")"  
									i=i+3"""
							if b[i] == 'ED':
								opcodeLocationDE=opcodesDE.index(b[i+1])
								if b[i+1] in special101:
									if i != 0:
										program += "\n"+(opcodesAssemblyDE[opcodeLocationDE])[:4]+"$"+b[i+3]+b[i+2]+(opcodesAssemblyDE[opcodeLocationDE])[4:]
									else:
										program += (opcodesAssemblyDE[opcodeLocationDE])[:4]+"$"+b[i+3]+b[i+2]+(opcodesAssemblyDE[opcodeLocationDE])[4:]
									i=i+4
								elif b[i+1] in special102:
									if i!= 0:
										program += "\n"+(opcodesAssemblyDE[opcodeLocationDE])[:7]+"$"+b[i+3]+b[i+2]+(opcodesAssemblyDE[opcodeLocationDE])[7:]
									else:
										program +=(opcodesAssemblyDE[opcodeLocationDE])[:7]+"$"+b[i+3]+b[i+2]+(opcodesAssemblyDE[opcodeLocationDE])[7:]
									i=i+2
								else:
									if i != 0:
										program += "\n"+(opcodesAssemblyDE[opcodeLocationDE])
									else:
										program += (opcodesAssemblyDE[opcodeLocationDE])
									i=i+2
								
							elif b[i] == 'CB':
								opcodeLocationCB=opcodes.index(b[i+1])
								if i!= 0:
									program += "\n"+(opcodesAssemblyCB[opcodeLocationCB])
								else:
									program +=(opcodesAssemblyCB[opcodeLocationCB])
								i=i+2
							
							elif b[i] == 'FD':
								opcodeLocationFD = opcodes.index(b[i+1])
								opcodeLocationFDCB=opcodes.index(b[i+1])
								if b[i] == '':
									program += 'nop'
								if b[i+1] == 'CB':
									opcodeLocationFDCB=opcodes.index(b[i+3])
									if b[i+3] in groupBits8:
										if i!=0:
											program +="\n"+((opcodesAssemblyFDCB[opcodeLocationFDCB])[:8])+str((hex2dec(b[i+2])))+((opcodesAssemblyFDCB[opcodeLocationFDCB])[8:])
										else:
											program +=((opcodesAssemblyFDCB[opcodeLocationFDCB])[:8])+str((hex2dec(b[i+2])))+((opcodesAssemblyFDCB[opcodeLocationFDCB])[8:])
									elif b[i+3] in groupBits7:
										if i!=0:
											program += "\n" + ((opcodesAssemblyFDCB[opcodeLocationFDCB])[:7])+str((hex2dec(b[i+2])))+((opcodesAssemblyFDCB[opcodeLocationFDCB])[7:])
										else:
											program += ((opcodesAssemblyFDCB[opcodeLocationFDCB])[:7])+str((hex2dec(b[i+2])))+((opcodesAssemblyFDCB[opcodeLocationFDCB])[7:])
									else:
										if i!=0:
											program += "\n" + ((opcodesAssemblyFDCB[opcodeLocationFDCB])[:10])+str((hex2dec(b[i+2])))+((opcodesAssemblyFDCB[opcodeLocationFDCB])[10:])
										else:
											program += ((opcodesAssemblyFDCB[opcodeLocationFDCB])[:10])+str((hex2dec(b[i+2])))((opcodesAssemblyFDCB[opcodeLocationFDCB])[10:])
									i=i+4
								
								elif b[i+1] in special1IX:
									if i!= 0:
										program += "\n"+(opcodesAssemblyFD[opcodeLocationFD])[:4]+"$"+b[i+3]+b[i+2]+(opcodesAssemblyFD[opcodeLocationFD])[4:]
									else:
										program += (opcodesAssemblyFD[opcodeLocationFD])[:4]+"$"+b[i+3]+b[i+2]+(opcodesAssemblyFD[opcodeLocationFD])[4:]
									i=i+4
								elif b[i+1] in special2IX:
									if i!=0:
										program += "\n"+(opcodesAssemblyFD[opcodeLocationFD])[:7]+"$"+b[i+3]+b[i+2]+(opcodesAssemblyFD[opcodeLocationFD])[7:]
									else:
										program += (opcodesAssemblyFD[opcodeLocationFD])[:7]+"$"+str(b[i+3]+b[i+2])+(opcodesAssemblyFD[opcodeLocationFD])[7:]
									i=i+4
								elif b[i+1] in special3IX:
									if i!=0:
										program += "\n"+(opcodesAssemblyFD[opcodeLocationFD])[:8]+"$"+b[i+2]+(opcodesAssemblyFD[opcodeLocationFD])[8:]
									else:
										program += (opcodesAssemblyFD[opcodeLocationFD])[:8]+"$"+b[i+2]+(opcodesAssemblyFD[opcodeLocationFD])[8:]
									i=i+3
								elif b[i+1] in special4IX:
									if i!= 0:
										program += "\n"+((opcodesAssemblyFD[opcodeLocationFD])[:7])+"$"+b[i+2]+((opcodesAssemblyFD[opcodeLocationFD])[7:]+("$"+str(b[i+3])))
									else:
										program += ((opcodesAssemblyFD[opcodeLocationFD])[:7])+"$"+b[i+2]+((opcodesAssemblyFD[opcodeLocationFD])[7:])+("$"+str(b[i+3]))
									i=i+4
								elif b[i+1] in special5IX:
									if i!= 0:
										program+= "\n"+(opcodesAssemblyFD[opcodeLocationFD])[:9]+"$"+b[i+2]+(opcodesAssemblyFD[opcodeLocationFD])[9:]
									else:
										program+= (opcodesAssemblyFD[opcodeLocationFD])[:9]+"$"+b[i+2]+(opcodesAssemblyFD[opcodeLocationFD])[9:]
									i=i+3
								elif b[i+1] in special6IX:
									if i!= 0:
										program+= "\n"+(opcodesAssemblyFD[opcodeLocationFD])[:7]+"$"+b[i+2]+(opcodesAssemblyFD[opcodeLocationFD])[7:]
									else:
										program+= (opcodesAssemblyFD[opcodeLocationFD])[:7]+"$"+b[i+2]+(opcodesAssemblyFD[opcodeLocationFD])[7:]
									i=i+3
								elif b[i+1] in special7IX:
									if i!= 0:
										program+= "\n"+(opcodesAssemblyFD[opcodeLocationFD])[:10]+str(hex2dec(b[i+2]))+(opcodesAssemblyFD[opcodeLocationFD])[10:]
									else:
										program+= (opcodesAssemblyFD[opcodeLocationFD])[:10]+str(hex2dec(b[i+2]))+(opcodesAssemblyFD[opcodeLocationFD])[10:]
									i=i+3
								elif b[i+1] in special8IX:
									if i!=0:
										program+= "\n"+(opcodesAssemblyFD[opcodeLocationFD])[:8]+"$"+str(b[i+2])+(opcodesAssemblyFD[opcodeLocationFD])[8:]
									else:
										program+= (opcodesAssemblyFD[opcodeLocationFD])[:8]+"$"+str(b[i+2])+(opcodesAssemblyFD[opcodeLocationFD])[8:]
									i=i+3
								elif b[i+1] in doubleAsteriskIX:
									if i!=0:
										program += "\n"+(opcodesAssemblyFD[opcodeLocationFD])+str(hex2dec(b[i+3]+b[i+2]))
									else:
										program += (opcodesAssemblyFD[opcodeLocationFD])+str(hex2dec(b[i+3]+b[i+2]))
									i=i+4
								elif b[i+1] in singleAsteriskIX:
									if i!=0:
										program += "\n"+(opcodesAssemblyFD[opcodeLocationFD])+str(hex2dec(b[i+2]))
									else:
										program += (opcodesAssemblyFD[opcodeLocationFD])+str(hex2dec(b[i+2]))
									i=i+3
								else:
									if i!= 0:
										program += "\n"+(opcodesAssemblyFD[opcodeLocationFD])
									else:
										program +=(opcodesAssemblyFD[opcodeLocationFD])
									i=i+2
								
							elif b[i] == 'DD':
								opcodeLocationDD = opcodes.index(b[i+1])
								opcodeLocationDDCB=opcodes.index(b[i+1])
								if b[i+1] == 'CB':
									opcodeLocationDDCB=opcodes.index(b[i+3])
									if b[i+3] in groupBits8:
										if i!=0:
											program +="\n"+((opcodesAssemblyDDCB[opcodeLocationDDCB])[:8])+"$"+(str(b[i+2]))+((opcodesAssemblyDDCB[opcodeLocationDDCB])[8:])
										else:
											program +=((opcodesAssemblyDDCB[opcodeLocationDDCB])[:8])+"$"+(str(b[i+2]))+((opcodesAssemblyDDCB[opcodeLocationDDCB])[8:])
									elif b[i+3] in groupBits7:
										if i!=0:
											program += "\n" + ((opcodesAssemblyDDCB[opcodeLocationDDCB])[:7])+"$"+(str(b[i+2]))+((opcodesAssemblyDDCB[opcodeLocationDDCB])[7:])
										else:
											program += ((opcodesAssemblyDDCB[opcodeLocationDDCB])[:7])+"$"+(str(b[i+2]))+((opcodesAssemblyDDCB[opcodeLocationDDCB])[7:])
									else:
										if i!=0:
											program += "\n" + ((opcodesAssemblyDDCB[opcodeLocationDDCB])[:10])+"$"+(str(b[i+2]))+((opcodesAssemblyDDCB[opcodeLocationDDCB])[10:])
										else:
											program += ((opcodesAssemblyDDCB[opcodeLocationDDCB])[:10])+(str(hex2dec(b[i+2])))+((opcodesAssemblyDDCB[opcodeLocationDDCB])[10:])
									i=i+4
								
								elif b[i+1] in special1IX:
									if i!= 0:
										program += "\n"+(opcodesAssemblyDD[opcodeLocationDD])[:4]+"$"+str(b[i+3]+b[i+2])+(opcodesAssemblyDD[opcodeLocationDD])[4:]
									else:
										program += (opcodesAssemblyDD[opcodeLocationDD])[:4]+"$"+str(b[i+3]+b[i+2])+(opcodesAssemblyDD[opcodeLocationDD])[4:]
									i=i+4
								elif b[i+1] in special2IX:
									if i!=0:
										program += "\n"+(opcodesAssemblyDD[opcodeLocationDD])[:7]+"$"+str(b[i+3]+b[i+2])+(opcodesAssemblyDD[opcodeLocationDD])[7:]
									else:
										program += (opcodesAssemblyDD[opcodeLocationDD])[:7]+"$"+str(b[i+3]+b[i+2])+(opcodesAssemblyDD[opcodeLocationDD])[7:]
									i=i+4
								elif b[i+1] in special3IX:
									if i!=0:
										program += "\n"+(opcodesAssemblyDD[opcodeLocationDD])[:8]+"$"+str(b[i+2])+(opcodesAssemblyDD[opcodeLocationDD])[8:]
									else:
										program += (opcodesAssemblyDD[opcodeLocationDD])[:8]+"$"+str(b[i+2])+(opcodesAssemblyDD[opcodeLocationDD])[8:]
									i=i+3
								elif b[i+1] in special4IX:
									if i!= 0:
										program += "\n"+((opcodesAssemblyDD[opcodeLocationDD])[:7])+"$"+str(b[i+2])+((opcodesAssemblyDD[opcodeLocationDD])[7:]+("$"+str(b[i+3])))
									else:
										program += ((opcodesAssemblyDD[opcodeLocationDD])[:7])+"$"+str(b[i+2])+((opcodesAssemblyDD[opcodeLocationDD])[7:])+("$"+str(b[i+3]))
									i=i+4
								elif b[i+1] in special5IX:
									if i!= 0:
										program+= "\n"+(opcodesAssemblyDD[opcodeLocationDD])[:9]+"$"+str(b[i+2])+(opcodesAssemblyDD[opcodeLocationDD])[9:]
									else:
										program+= (opcodesAssemblyDD[opcodeLocationDD])[:9]+"$"+str(b[i+2])+(opcodesAssemblyDD[opcodeLocationDD])[9:]
									i=i+3
								elif b[i+1] in special6IX:
									if i!= 0:
										program+= "\n"+(opcodesAssemblyDD[opcodeLocationDD])[:7]+"$"+str(b[i+2])+(opcodesAssemblyDD[opcodeLocationDD])[7:]
									else:
										program+= (opcodesAssemblyDD[opcodeLocationDD])[:7]+"$"+str(b[i+2])+(opcodesAssemblyDD[opcodeLocationDD])[7:]
									i=i+3
								elif b[i+1] in special7IX:
									if i!= 0:
										program+= "\n"+(opcodesAssemblyDD[opcodeLocationDD])[:10]+"$"+str(b[i+2])+(opcodesAssemblyDD[opcodeLocationDD])[10:]
									else:
										program+= (opcodesAssemblyDD[opcodeLocationDD])[:10]+str(hex2dec(b[i+2]))+(opcodesAssemblyDD[opcodeLocationDD])[10:]
									i=i+3
								elif b[i+1] in special8IX:
									if i!=0:
										program+= "\n"+(opcodesAssemblyDD[opcodeLocationDD])[:8]+"$"+str(b[i+2])+(opcodesAssemblyDD[opcodeLocationDD])[8:]
									else:
										program+= (opcodesAssemblyDD[opcodeLocationDD])[:8]+"$"+str(b[i+2])+(opcodesAssemblyDD[opcodeLocationDD])[8:]
									i=i+3
								elif b[i+1] in doubleAsteriskIX:
									if i!=0:
										program += "\n"+(opcodesAssemblyDD[opcodeLocationDD])+str(hex2dec(b[i+3]+b[i+2]))
									else:
										program += (opcodesAssemblyDD[opcodeLocationDD])+str(hex2dec(b[i+3]+b[i+2]))
									i=i+4
								elif b[i+1] in singleAsteriskIX:
									if i!=0:
										program += "\n"+(opcodesAssemblyDD[opcodeLocationDD])+str(hex2dec(b[i+2]))
									else:
										program += (opcodesAssemblyDD[opcodeLocationDD])+str(hex2dec(b[i+2]))
									i=i+3
								else:
									if i!= 0:
										program += "\n"+(opcodesAssemblyDD[opcodeLocationDD])
									else:
										program +=(opcodesAssemblyDD[opcodeLocationDD])
									i=i+2
							
							else:
								if b[i] in labels1:
									if i!= 0:
										program += "\n"+ (opcodesAssembly[opcodeLocation]) + "$"+b[i+1]
									else:
										program += (opcodesAssembly[opcodeLocation]) + "$"+b[i+1]
									i=i+2
								elif b[i] in labels2:
									if i!= 0:
										program += "\n" + (opcodesAssembly[opcodeLocation]) + "$"+b[i+2]+b[i+1]
									else:
										program += (opcodesAssembly[opcodeLocation]) + "$"+b[i+2]+b[i+1]
									i=i+3
								elif b[i] in special1:
									if i != 0:
										program += "\n"+(opcodesAssembly[opcodeLocation])[:3]+"$"+str(b[i+2]+b[i+1])+(opcodesAssembly[opcodeLocation])[3:]
									else:
										program += (opcodesAssembly[opcodeLocation])[:3]+"$"+str(b[i+2]+b[i+1])+(opcodesAssembly[opcodeLocation])[3:]
									i=i+3
								elif b[i] in special2:
									if i != 0:
										program += "\n"+(opcodesAssembly[opcodeLocation])[:7]+"$"+str(b[i+2]+b[i+1])+(opcodesAssembly[opcodeLocation])[7:]
									else:
										program += (opcodesAssembly[opcodeLocation])[:7]+"$"+str(b[i+2]+b[i+1])+(opcodesAssembly[opcodeLocation])[7:]
									i=i+3
								elif b[i] in special3:
									if i != 0:
										program += "\n"+(opcodesAssembly[opcodeLocation])[:6]+str(hex2dec(b[i+2]+b[i+1]))+(opcodesAssembly[opcodeLocation])[6:]
									else:
										program += (opcodesAssembly[opcodeLocation])[:6]+str(hex2dec(b[i+2]+b[i+1]))+(opcodesAssembly[opcodeLocation])[6:]
									i=i+3
								elif b[i] in special4:
									if i != 0:
										program += "\n"+(opcodesAssembly[opcodeLocation])[:5]+'$'+str(b[i+1])+(opcodesAssembly[opcodeLocation])[5:]
									else:
										program += (opcodesAssembly[opcodeLocation])[:5]+'$'+str(b[i+1])+(opcodesAssembly[opcodeLocation])[5:]
									i=i+2
								elif b[i] in special5:
									if i!= 0:
										program += "\n"+(opcodesAssembly[opcodeLocation])[:6]+'$'+str(b[i+1])+(opcodesAssembly[opcodeLocation])[6:]
									else:
										program += (opcodesAssembly[opcodeLocation])[:6]+'$'+str(b[i+1])+(opcodesAssembly[opcodeLocation])[6:]
									i=i+2
								elif b[i] in doubleAsterisk:
									if i != 0:
										program+="\n"+(opcodesAssembly[opcodeLocation])+str(hex2dec(b[i+2]+b[i+1]))
									else:
										program+=(opcodesAssembly[opcodeLocation])+str(hex2dec(b[i+2]+b[i+1]))
									i=i+3
								elif b[i] in singleAsterisk:
									if i != 0:
										program+="\n"+(opcodesAssembly[opcodeLocation])+str(hex2dec(b[i+1]))
									else:
										program+=(opcodesAssembly[opcodeLocation])+str(hex2dec(b[i+1]))
									i=i+2
								else:
									if i != 0:
										program+="\n"+(opcodesAssembly[opcodeLocation])
									else:
										program+=(opcodesAssembly[opcodeLocation])
									i=i+1
						self.outputText.SetValue(program)
				else:
					errorBox = wx.MessageDialog(None, 'ERROR: Invalid/Odd number of bytes','Error Found During Conversion', wx.OK)
					errorAnswer = errorBox.ShowModal()
					errorBox.Destroy()
		elif a == "":
			self.outputText.SetValue("")
		
		else:
			errorBox = wx.MessageDialog(None, 'ERROR: Non-Hexadecimal Characters in Input Code','Error Found During Conversion', wx.OK)
			errorAnswer = errorBox.ShowModal()
			errorBox.Destroy()
	
	
	#DEFINE EVENTS
	self.inputText.Bind(wx.EVT_SET_FOCUS,GiveInputFocus)
	self.inputText.Bind(wx.EVT_KILL_FOCUS,RemoveInputFocus)
	
	self.outputText.Bind(wx.EVT_SET_FOCUS,GiveOutputFocus)
	self.outputText.Bind(wx.EVT_KILL_FOCUS,RemoveOutputFocus)
	
	self.inputText.Bind(wx.EVT_TEXT_ENTER,OnUpdateInputText)
	self.Bind(wx.EVT_MENU,OnUpdateInputText, id=1)
	self.Bind(wx.EVT_MENU,Get8xData,id=22)
	
	self.Bind(wx.EVT_MENU,OnAbout,id=2)
	self.Bind(wx.EVT_MENU,OnGetOnlineHelp,id=24)
	
	self.Bind(wx.EVT_MENU,OnSaveASM,id=3)
	self.Bind(wx.EVT_MENU,OnSaveHEX,id=4)
	self.Bind(wx.EVT_MENU,OnExport8xp,id=25)
	
	self.Bind(wx.EVT_MENU,OnQuit,id=5)
	self.Bind(wx.EVT_MENU,OnOpen,id=6)
	self.Bind(wx.EVT_MENU,NewFile,id=7)
	self.Bind(wx.EVT_MENU,OnSaveASMHEX,id=8)
	
	self.Bind(wx.EVT_MENU,SelectAll,id=9)
	self.Bind(wx.EVT_MENU,Cut,id=10)
	self.Bind(wx.EVT_MENU,Copy,id=11)
	self.Bind(wx.EVT_MENU,Paste,id=12)
	self.Bind(wx.EVT_MENU,Clear,id=13)
	self.Bind(wx.EVT_MENU,Undo,id=14)
	self.Bind(wx.EVT_MENU,Redo,id=15)
	self.Bind(wx.EVT_MENU,FindReplace,id=20)
	self.Bind(wx.EVT_MENU,CountWords,id=23)
	
	self.Bind(wx.EVT_MENU,Num2Hex,id=18)
	self.Bind(wx.EVT_MENU,Hex2Num,id=19)
	
	
if __name__=='__main__':
    app=wx.PySimpleApp()
    frame=MainFrame(parent=None, id= -1)
    frame.Show()
    frame.Maximize()	
    app.MainLoop()